// ssh root@45.55.86.16

var socketio_endpoint = "http://45.55.86.16:81";
var app_endpoint = "http://192.81.216.10:8080/app/api";
//var app_endpoint = "http://localhost:8180/app/api";
//var app_endpoint = "http://192.81.216.10:8080/app/api";
//var app_endpoint = "http://192.168.1.134:8180/app/api";
//var app_endpoint = "http://192.168.43.206:8180/app/api";

var companyId = 1;
var versionNumber = 1;

//var app_endpoint = "http://192.168.1.134:8180/app/api";
//var companyId = 3;


var server_time_zone = '-0500';
var date_format = 'dd/MM/yyyy';
var time_format = 'h:mm:ss a';
var date_time_format = date_format + ' ' + time_format;
var gcm_sender_id = "660672612788";

var autoLogin = null;

var locale = 'es';

String.prototype.paddingLeft = function (paddingValue) {
   return String(paddingValue + this).slice(-paddingValue.length);
};
	
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'pascalprecht.translate', 'ngCordova', 'jrCrop', 'angular-inview', 'ui.rCalendar'])
.config(function($compileProvider){
  $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel|data):/);
})
.config(function($ionicConfigProvider) {
  $ionicConfigProvider.backButton.text('');
})
.filter('trustAsResourceUrl', ['$sce', function($sce) {
    return function(val) {
        return $sce.trustAsResourceUrl(val);
    };
}])
.directive('ngEnter', function() {
	return function(scope, element, attrs) {
	  element.bind("keydown keypress", function(event) {
	    if(event.which === 13) {
	      scope.$apply(function(){
	      	scope.$eval(attrs.ngEnter);
	      });
	      event.preventDefault();
	    }
	  });
	};
})
.directive('focusOn', function() {
   return function(scope, elem, attr) {
      scope.$on(attr.focusOn, function(e) {
          elem[0].focus();
      });
   };
})
.directive('qrcode', function($interpolate) {
  return {
    restrict: 'E',
    link: function($scope, $element, $attrs) {

      var options = {
        text: '',
        width: 128,
        height: 128,
        colorDark: '#000000',
        colorLight: '#ffffff',
        correctLevel: 'H'
      };

      Object.keys(options).forEach(function(key) {
        options[key] = $interpolate($attrs[key] || '')($scope) || options[key];
      });

      options.correctLevel = QRCode.CorrectLevel[options.correctLevel];

      new QRCode($element[0], options);

    }
  };
})
.directive('imageonload', function() {
  return {
    restrict: 'A',
    link: function(scope, element, attrs) {
      var image = new Image();
      image.onload = function() {
        scope.$apply(attrs.imageonload);
      };
      image.src = attrs.ngSrc;
    }
  };
})
.directive('backImg', function(){
    return function(scope, element, attrs){
        attrs.$observe('backImg', function(value) {
            element.css({
                'background-image': 'url(' + value +')',
                'background-size' : 'cover'
            });
        });
    };
})
.run(function($ionicPlatform, userService, $state, $rootScope, _, $ionicHistory, notifications, backend, $ionicModal, eventService, storage, notifications) {
    /*window.addEventListener("message", function(event) {
        var data = event.data || event.originalEvent.data;
        if (data == "successPay") {
            $rootScope.$broadcast("successPay");
        }
    }, false);*/
	$ionicPlatform.ready(function() {
		if(window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
			cordova.plugins.Keyboard.disableScroll(true);
		}
		if(window.StatusBar) {
			StatusBar.styleDefault();
		}
		if (facebookConnectPlugin.browserInit) {
			var appID = 244523332568622;
			var version = "v2.0";
			facebookConnectPlugin.browserInit(appID, version);
		}
		notifications.register();
	});
  $rootScope.dateFormat = date_format;
  $rootScope.serverTimeZone = server_time_zone;
  $rootScope.dateTimeFormat = date_time_format;
  $rootScope.app_endpoint = backend.getBaseEndpoint();

  $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
	  if(storage.getObject('pendingPurchase') != null) {
		  $ionicHistory.nextViewOptions({
			  disableAnimate: true,
			  disableBack: true
		  });
		  $state.go("waitTransactionNumber");
	  }
  });
  $ionicPlatform.ready(function() {
    notifications.bindEvent();
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
  });
  $rootScope.showCompany = function(company) {
	  var $scope = $rootScope.$new();
	  $scope.search = {query: ''};
	  $scope.lastLoaded = false;
	  $scope.toggleLike = function(event) {
		  userService.showLogin(function() {
			  eventService.toggleLike(event, function(liked){
				  event.liked = liked;
				  $rootScope.$emit('events.liked', {eventId: event.id, liked: liked});
			  });
		  });
	  };
	  $scope.loading = false;
	  $scope.events = [];
	  $scope.$watch('search.query', function() {
		  $scope.doRefresh();
	  });
	  $scope.doRefresh = function() {
		  $scope.events = [];
		  $scope.lastLoaded = false;
		  $scope.loadMore();
	  };
	  $scope.loadMore = function() {
			if (!$scope.loading) {
				$scope.loading = true;
				eventService.listByCompany(company.id, $scope.events.length, $scope.search.query, function(result) {
					if (!result || result.length == 0) {
						$scope.lastLoaded = true;
					} else {
						$scope.events = $scope.events.concat(result);
					}
				    $scope.$broadcast('scroll.infiniteScrollComplete');
				    $scope.$broadcast('scroll.refreshComplete');
				    $scope.loading = false;
			    });
			}
	  };
	  $scope.openEvent = function(event) {
		  eventService.openEvent(event, $scope);
	  };
	  $scope.doRefresh();
	  $scope.currentCompany = company;
	  $scope.openConversation = function() {
		  $ionicModal.fromTemplateUrl('templates/conversation.html', {
		      scope: $scope,
		      animation: 'slide-in-up'
		  }).then(function(modal) {
		    	$scope.conversationModal = modal;
			    $scope.conversationModal.show();
		  });
		  $scope.$on('$destroy', function() {
				$scope.conversationModal.remove();
		  });
	  };
	  $ionicModal.fromTemplateUrl('templates/company.html', {
	      scope: $scope,
	      animation: 'slide-in-up'
	  }).then(function(modal) {
	    	$scope.companyModal = modal;
		    $scope.companyModal.show();
	  });
	  $scope.$on('$destroy', function() {
			$scope.companyModal.remove();
	  });
	  $scope.closeCompanyModal = function() {
		  $scope.companyModal.hide().then(function() {
			  $scope.$destroy();
		  });
	  };
  };
})
// translate configuration
.config(['$translateProvider', function($translateProvider) {
  $translateProvider.useSanitizeValueStrategy('escape');
  $translateProvider.useStaticFilesLoader({
    prefix: 'i18n/messages-',
    suffix: '.json'
  });
  $translateProvider.preferredLanguage(locale);
  }])
.config(function($stateProvider, $urlRouterProvider) {
  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })
  .state('app.events', {
	  url: '/events',
	  views: {
	    'menuContent': {
	      templateUrl: 'templates/events.html',
	      controller: 'EventsCtrl'
	    }
	  }
  })
  .state('app.notifications', {
      url: '/notifications',
      views: {
        'menuContent': {
          templateUrl: 'templates/notifications.html',
          controller: 'NotificationsCtrl'
        }
      }
  })
  .state('app.settings', {
	  url: '/settings',
	  views: {
	    'menuContent': {
	      templateUrl: 'templates/settings.html',
	      controller: 'SettingsCtrl'
	    }
	  }
  })
  .state('app.myTickets', {
	  url: '/myTickets',
	  views: {
	    'menuContent': {
	      templateUrl: 'templates/myTickets.html',
	      controller: 'MyTicketsCtrl'
	    }
	  }
  })
  .state('waitTransactionNumber', {
	  url: '/waitTransactionNumber',
	  templateUrl: 'templates/waitTransactionNumber.html',
	  controller: 'WaitTransactionNumberCtrl'
  })
  .state('app.myProfile', {
    url: '/myProfile',
    views: {
    	'menuContent': {
    		templateUrl: 'templates/myProfile.html',
    	    controller: 'MyProfileCtrl'
    	}
    }
  })
  .state('app.changePassword', {
    url: '/changePassword',
    views: {
    	'menuContent': {
    		templateUrl: 'templates/changePassword.html',
    	    controller: 'ChangePasswordCtrl'
    	}
    }
  })
  ;
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/events');
});
